{
 This component was created by Ido Kanner. Email: ik_5@hotmail.com
 I publish this component under the GNU licence (http://www.gnu.org/licenses/gpl.html).

 I also request that any bug fixing or additional code that you publish on your own, please
 send me a copy of that code.

 History:
 4-11/5/03 - Component created and cleaned from all annoing bugs that was found.
             I wish to thanks Uri Hartman for helping me with bug testing...

 Component Version: 1.0
}
{$IFDEF Linux}
 This Component does not support linux or kylix !!!
{$ENDIF}
unit LanguageChanger;

interface

uses
  SysUtils, Classes, Controls, Menus, Windows, Messages, Forms;
                      
const
 MaxLanguaes = 143; //Acording to microsoft there are 143 languages that windows can support
                    //(in all of the avialbe version (last checked time 04/05/2003)

 LT_ID          = 0;
 LT_LOCOLIZED   = 1;
 LT_ENGLISHNAME = 2;
 LT_SHORTNAME   = 3;
 LT_NATIVENAME  = 4;
 LT_EXTANTION   = 5;

 LTS_ID          = 'ID';
 LTS_LOCOLIZED   = 'LOCOLIZED';
 LTS_ENGLISHNAME = 'ENGLISH';
 LTS_SHORTNAME   = 'SHORT';
 LTS_NATIVENAME  = 'NATIVE';
 LTS_EXTANTION   = 'EXT';

type
  TrecLang = record
              strLongLangID      : string;  //The hexa number of the language identifier (the long number -> trailing zerows)
              strLangID          : string;  //The hexa number of the langue identifier
              hklLangID          : HKL;     //The Integer number of the language identifier
              intILANGUAGE       : Integer; //The id of the language...
              strSLANGUAGE       : string;  //The locolized name of the language
              strSENGLANGUAGE    : string;  //The English name of the language
              strSABBREVLANGNAME : string;  //The short name of the language
              strSNATIVELANGNAME : string;  //The native name (ie in the name in it's own language) of the language
              strExtention       : string;  //The Extention of the language (ie the short name, but only with 2 letters)
             end;

  TLangs   = array[0..MaxLanguaes-1] of TrecLang;
  TLayouts = array of HKL;

  TBeforeLanguageChangesEvent = procedure (Sender : TObject; CurrentLanguage, NewLanguage : TrecLang) of object;
  TAftherLangueChangedEvent   = procedure (Sender : TObject; NewLanguage : TrecLang) of object;

  TListType = (ltID, ltLocolized, ltEnglishName, ltShortName, ltNativeName, ltExtantion);

  TCurrentLanguages = class(TComponent)
  private
    { Private declarations }
    FOriginalMessageHandler : TMessageEvent;

    FAftherLanguageChanges  : TAftherLangueChangedEvent;
    FBeforeLanguageChanges  : TBeforeLanguageChangesEvent;

    FLayoutID,
    FLayoutLocolizedName,
    FLayoutEnglishName,
    FLayoutShortName,
    FLayoutNativeName,
    FLayoutExtention        : string;
    FAutoRefresh            : Boolean;

    procedure SetLayoutID        (const Value : string);
    procedure SetLocolizedName   (const Value : string);
    procedure SetEnglishName     (const Value : string);
    procedure SetShortName       (const Value : string);
    procedure SetNativeName      (const Value : string);
    procedure SetLayoutExtention (const Value : string);
    procedure SetAutoRefresh     (const Value : Boolean);
  protected
    { Protected declarations }
    procedure MessageHandler (var Msg: TMsg; var Handled: Boolean); virtual;
  public
    { Public declarations }
    constructor Create (AOwner : TComponent); overload; override;
    constructor Create (AOwner : TComponent; Layout : HKL); overload; virtual;
    constructor Create (AOwner : TComponent; InFile : string); overload; virtual;
    destructor Destroy; override;

    procedure InitilizeLanguagesLists; virtual;

    function CountLayouts : Integer; virtual; //If return 0 then an error was found... no Exception will raise by the function.

    function AvilableLayouts (out Layouts : TLayouts) : Boolean; virtual;

    function GetLanguageData          (Layout : HKL; Data_Type : Integer; out Data : string) : Boolean; virtual;
    function GetLanguageID            (Layout : HKL; out ID   : string) : Boolean; virtual;
    function GetLanguageLocolizedName (Layout : HKL; out Name : string) : Boolean; virtual;
    function GetLanguageEnglishName   (Layout : HKL; out Name : string) : Boolean; virtual;
    function GetLanguageShortenName   (Layout : HKL; out Name : string) : Boolean; virtual;
    function GetLanguageNativeName    (Layout : HKL; out Name : string) : Boolean; virtual;
    function GetLanguageExtentionName (Layout : HKL; out Name : string) : Boolean; virtual;

    function FillArray (Layout : HKL; out recLang : TrecLang) : Boolean; virtual;
    procedure MakeListFromLayouts (Layouts : TLayouts; out Languages : TLangs); virtual;
    procedure Refresh; virtual;

    function GetActiveLayout : HKL;

    function ActiveLayout (Layout   : HKL)      : Boolean; overload; virtual;
    function ActiveLayout (Layout   : TrecLang) : Boolean; overload; virtual;
    function NextLayout    : Boolean; virtual;
    function PreviousLayout : Boolean; virtual;

    //I recoomand to set the .lut extntion... but you can use any type of extention that you wish...
    procedure SaveToFile (Layout : TrecLang; OutFile : string); virtual;
    procedure LoadFromFile (InFile : string; out Layout : TrecLang); virtual;

    procedure SetLayoutList (ListType : TListType; List : TStrings); overload; virtual;
    procedure SetLayoutList (ListType : Integer;   List : TStrings); overload; virtual;
    procedure SetLayoutList (ListType : string;    List : TStrings); overload; virtual;

    function GetIDFromRecord(DataType : TListType; Value : string) : HKL; virtual;

    property Handle: HKL read GetActiveLayout;
    property AutoRefresh : Boolean read FAutoRefresh write SetAutoRefresh;
  published
    { Published declarations }
    property LayoutID              : string                      read FLayoutID              write SetLayoutID;
    property LayoutLocolizedName   : string                      read FLayoutLocolizedName   write SetLocolizedName;
    property LayoutEnglishName     : string                      read FLayoutEnglishName     write SetEnglishName;
    property LayoutShortName       : string                      read FLayoutShortName       write SetShortName;
    property LayoutNativeName      : string                      read FLayoutNativeName      write SetNativeName;
    property LayoutExtention       : string                      read FLayoutExtention       write SetLayoutExtention;
    //////////////////////////// Events \\\\\\\\\\\\\\\\\\\\\\\\\\\\
    property AftherLanguageChanges : TAftherLangueChangedEvent   read FAftherLanguageChanges write FAftherLanguageChanges;
    property BeforeLanguageChanges : TBeforeLanguageChangesEvent read FBeforeLanguageChanges write FBeforeLanguageChanges;
  end;

 EFileError        = class(Exception);
 EUnknownIdentifer = class(Exception);


function MAKELCID (wLanguageID, wSortID : Word) : DWORD;

function GetLocaleDataA (ID: LCID; Flag: DWORD; out Size : Integer) : string; //A change of the original SysUtil internal function
function GetLocaleDataW (ID: LCID; Flag: DWORD; out Size : Integer) : string; //A change of the original SysUtil internal function

var
 LanguagesList : TLangs;
 LayoutNum     : Integer;

implementation

function MAKELCID (wLanguageID, wSortID : Word) : DWORD;
begin
  Result := (wSortID SHL 16) or (wLanguageID);
end;

{ Query the OS for information for a specified locale. ANSI Version. Works correctly on Asian Win95. }
function GetLocaleDataA(ID: LCID; Flag: DWORD; out Size : Integer): string;
var
  Buffer : array[0..1023] of Char;
begin
  Buffer[0] := #0;
  Size := GetLocaleInfoA(ID, Flag, Buffer, SizeOf(Buffer));
  SetString(Result, Buffer, Size - 1);
end;

{ Query the OS for information for a specified locale. Unicode version. Works correctly on Asian WinNT. }
function GetLocaleDataW(ID: LCID; Flag: DWORD; out Size : Integer): string;
var
  Buffer: array[0..1023] of WideChar;
begin
  Buffer[0] := #0;
  Size := GetLocaleInfoW(ID, Flag, Buffer, SizeOf(Buffer) div 2);
  Result := Buffer;
end;

constructor TCurrentLanguages.Create(AOwner : TComponent);
begin
 inherited Create(AOwner);

 InitilizeLanguagesLists;
 Refresh;

 FAutoRefresh := False;

 if not (csDesigning in ComponentState) then //We do not want to "hack" into delphi IDE itself
   begin
    FOriginalMessageHandler := Application.OnMessage;
    Application.OnMessage   := MessageHandler;
   end;

end;

constructor TCurrentLanguages.Create(AOwner : TComponent; Layout : HKL);
begin
 Create(AOwner);
 ActiveLayout(Layout);
end;

constructor TCurrentLanguages.Create(AOwner : TComponent; InFile : string);
var
 tmpRec : TrecLang;
begin
 Create(AOwner);
 LoadFromFile(InFile,tmpRec);
 ActiveLayout(tmpRec);
end;

destructor TCurrentLanguages.Destroy;
begin
 inherited Destroy;
end;

procedure TCurrentLanguages.MessageHandler(var Msg: TMsg; var Handled: Boolean);
var
 CurrentLanguage,
 NewLanguage      : TrecLang;
begin
//According to the api guide, you can not capture this message.
//You must listn to all the messages and then you will find the
//wanted message...
 if (Msg.message = WM_INPUTLANGCHANGEREQUEST)or(Msg.message = WM_INPUTLANGCHANGE) then
  begin
   //The api guide clamies that we need this funtion if we wish to pass the message
   //and make it active... if we do not uses this function windows reject the request...
   if Assigned(FBeforeLanguageChanges) then
    begin
     FillArray(GetActiveLayout, CurrentLanguage);
     FillArray(Msg.lParam,      NewLanguage);

     FBeforeLanguageChanges(Self,CurrentLanguage, NewLanguage); //Need to put the real data where the null at
    end;

   DefWindowProc(Application.Handle,Msg.message, Msg.wParam, Msg.lParam); //Now that we processed the message we are going to use it

   if not (csDesigning in ComponentState) then
      begin

       InitilizeLanguagesLists;

       if FAutoRefresh then
        Refresh;

       if Assigned(FAftherLanguageChanges) then
        begin
         Application.OnMessage := nil;
         FillArray(GetActiveLayout,CurrentLanguage);
         FAftherLanguageChanges(Self, CurrentLanguage);
         Application.OnMessage := MessageHandler; //return the original message handler procedure
        end;
      end;
  end;

 if Assigned(FOriginalMessageHandler) then
   FOriginalMessageHandler(Msg,Handled);
end; 

procedure TCurrentLanguages.InitilizeLanguagesLists;
begin
 GetLanguageID(GetActiveLayout,FLayoutID);
 GetLanguageLocolizedName(GetActiveLayout,FLayoutLocolizedName);
 GetLanguageEnglishName(GetActiveLayout,FLayoutEnglishName);
 GetLanguageShortenName(GetActiveLayout, FLayoutShortName);
 GetLanguageNativeName(GetActiveLayout,FLayoutNativeName);
 GetLanguageExtentionName(GetActiveLayout, FLayoutExtention);
end;

function TCurrentLanguages.CountLayouts : Integer;
var
 arrLayouts    : array[0..1] of HKL;
begin
 FillChar(arrLayouts,SizeOf(arrLayouts),#0);

 Result := GetKeyboardLayoutList(SizeOf(arrLayouts),arrLayouts[0]);
end;

function TCurrentLanguages.AvilableLayouts(out Layouts : TLayouts) : Boolean;
var
 arrLayouts    : array[0..MaxLanguaes-1] of HKL;
 intLayoutsNum : Integer;
 intCounter    : Integer;
begin
 //Initilize the result of the function... if no error was eccured then it will be changed at the end
 Result := False;
 //Initilize the variable
 FillChar(arrLayouts,SizeOf(arrLayouts),#0);

 //Get the list of all installed layouts in the system
 //intLayoutsNum need to have a number... if it's 0 then something is wrong...
 //Other numbers are the number of layouts exits in the system...
 intLayoutsNum := GetKeyboardLayoutList(SizeOf(arrLayouts),arrLayouts[0]);

 //Did we have an error returnd to us ....?
 if (intLayoutsNum <= 0) then
  begin //Then exit the function (False value will reacived
   Exit;
  end;

 //Error Handeling... this error message never needs to apear ! but if it does so something is wrong...
 Assert(intLayoutsNum >= 1,'The function AvilableLayouts reports: intLayoutsNum variable was not initilized currectly.');

 //Initilize the Layouts variable with the needed size
 SetLength(Layouts,intLayoutsNum);

 //Error Handeling... if the array was not initlized currectly then report it and exit the function...
 Assert(High(Layouts)=intLayoutsNum-1,'The function AvilableLayouts reports: The array Layouts was not initilized currectly.');

 //Sets the data to the Layouts var.
 for intCounter := 0 to intLayoutsNum-1 do
  begin
   Layouts[intCounter] := arrLayouts[intCounter];
  end;

 //Setting the result to true.... no error was found and the Layouts variable assumed to bee filled up with the data.
 Result := True;
end;

function TCurrentLanguages.GetLanguageData(Layout : HKL; Data_Type : Integer; out Data : string) : Boolean;
var
 Names             : string; //array[0..255] of Char;
 Local,
 Size              : Integer;
 GetLocaleDataProc : function (ID: LCID; Flag: DWORD; out Size : Integer): string;
begin
 //initilize the variables
 FillChar(Names,SizeOf(Names),#0);
 Result := False;
 Data := '';

 Local := MAKELCID(Layout,SORT_DEFAULT);

 if (Win32Platform = VER_PLATFORM_WIN32_NT) then
  GetLocaleDataProc := @GetLocaleDataW
 else
  GetLocaleDataProc := @GetLocaleDataA;

 Names := GetLocaleDataProc(Local, Data_Type, Size);

 if Size<=0 then
  Exit;

 Data := Names;

 //Should never executed once we came to this place.... but we must be prepered for the unknown errors...
 Assert(Trim(Data)<>'',Format('The function GetLanguageData reports: Unable to extract the requested data %d for the language.',[Data_Type]));

 Result := True;
end;

function TCurrentLanguages.GetLanguageID(Layout : HKL; out ID : string) : Boolean;
begin
 Result := False;

 if (GetLanguageData(Layout,LOCALE_ILANGUAGE,ID)) then
  begin
   //Should never ever happen but just in case !!!
   Assert(Trim(ID)<>'','The function GetLanguageID reports: The data for the ID variable is empty.');
   Result := True;
  end;

end;

function TCurrentLanguages.GetLanguageLocolizedName(Layout : HKL; out Name : string) : Boolean;
begin
 Result := False;
 if (GetLanguageData(Layout,LOCALE_SLANGUAGE,Name)) then
  begin
   //Should never ever happen but just in case !!!
   Assert(Trim(Name)<>'', 'The function GetLanguageLocolizedName reports: The data for the Name variable is emprt.');
   Result := True;
  end;
end;

function TCurrentLanguages.GetLanguageEnglishName(Layout : HKL; out Name : string) : Boolean;
begin
 Result := False;
 if (GetLanguageData(Layout,LOCALE_SENGLANGUAGE,Name)) then
  begin
   //Should never ever happen but just in case !!!
   Assert(Trim(Name)<>'', 'The function GetLanguageEnglishName reports: The data for the Name variable is emprt.');
   Result := True;
  end;
end;

function TCurrentLanguages.GetLanguageShortenName(Layout : HKL; out Name : string) : Boolean;
begin
 Result := False;
 if (GetLanguageData(Layout,LOCALE_SABBREVLANGNAME,Name)) then
  begin
   //Should never ever happen but just in case !!!
   Assert(Trim(Name)<>'', 'The function GetLangaugeShortenName reports: The data for the Name variable is emprt.');
   Result := True;
  end;
end;

function TCurrentLanguages.GetLanguageNativeName(Layout : HKL; out Name : string) : Boolean;
begin
 Result := False;
 if (GetLanguageData(Layout,LOCALE_SNATIVELANGNAME,Name)) then
  begin
   //Should never ever happen but just in case !!!
   Assert(Trim(Name)<>'', 'The function GetLanguageNativeName reports: The data for the Name variable is emprt.');
   Result := True;
  end;
end;

function TCurrentLanguages.GetLanguageExtentionName(Layout : HKL; out Name : string) : Boolean;
var
 strTemp : string;
begin
 Result := False;
 if (GetLanguageShortenName(Layout,strTemp)) then
  begin
   //Should never ever happen but just in case !!!
   Assert(Trim(strTemp)<>'', 'The function GetLanguageExtentionName reports: The data for the strTemp variable is emprt.');
   Name := Copy(strTemp,1,2);

   Result := True;
  end;
end;

function TCurrentLanguages.FillArray(Layout : HKL; out recLang : TrecLang) : Boolean;
var
 strTemp : string;
 tmpRec  : TrecLang;
begin
 Result := False;

 tmpRec.strLongLangID := IntToHex(Layout,8);
 tmpRec.strLangID     := IntToHex(Layout,1);
 tmpRec.hklLangID     := Layout;

 if (GetLanguageID(Layout,strTemp)) then
  begin
   tmpRec.intILANGUAGE := StrToInt('$'+strTemp);
  end
 else Exit;

 if (GetLanguageLocolizedName(Layout,strTemp)) then
  begin
   tmpRec.strSLANGUAGE := strTemp;
  end
 else Exit;

 if (GetLanguageEnglishName(Layout,strTemp)) then
  begin
   tmpRec.strSENGLANGUAGE := strTemp
  end
 else Exit;

 if (GetLanguageShortenName(Layout, strTemp)) then
  begin
   tmpRec.strSABBREVLANGNAME := strTemp;
  end
 else Exit;

 if (GetLanguageNativeName(Layout,strTemp)) then
  begin
    tmpRec.strSNATIVELANGNAME := strTemp;
  end
 else Exit;

 if (GetLanguageExtentionName(Layout,strTemp)) then
  begin
   tmpRec.strExtention := strTemp;
  end
 else Exit;

 recLang := tmpRec;
 Result := True;
end;

procedure TCurrentLanguages.MakeListFromLayouts(Layouts : TLayouts; out Languages : TLangs);
var
 i       : Integer;
begin
 FillChar(Languages,SizeOf(Languages),#0);

 for i:= Low(Layouts) to High(Layouts) do
  begin
   FillArray(Layouts[i], Languages[i]);
  end;
end;

procedure TCurrentLanguages.Refresh;
var
 Layouts : TLayouts;
begin
 AvilableLayouts(Layouts);
 MakeListFromLayouts(Layouts,LanguagesList);
end;

function TCurrentLanguages.GetActiveLayout : HKL;
begin
 Result := GetKeyboardLayout(0);
end;

function TCurrentLanguages.ActiveLayout(Layout : HKL) : Boolean;
begin
 Result := (ActivateKeyboardLayout(Layout, 0) <> 0);

 InitilizeLanguagesLists;

 if FAutoRefresh then
  Refresh;

end;

function TCurrentLanguages.ActiveLayout(Layout : TrecLang) : Boolean;
begin
 Result := ActiveLayout(Layout.hklLangID);
end;

function TCurrentLanguages.NextLayout : Boolean;
begin
 Result := ActiveLayout(HKL_NEXT);
end;

function TCurrentLanguages.PreviousLayout : Boolean;
begin
 Result := ActiveLayout(HKL_PREV);
end;

procedure TCurrentLanguages.SaveToFile(Layout : TrecLang; OutFile : String);
var
  strmFile : TFileStream;
begin
 strmFile := TFileStream.Create(OutFile, fmCreate);

 try
  strmFile.WriteBuffer(Layout,SizeOf(Layout));
 finally
  strmFile.Free;
 end;

end;

procedure TCurrentLanguages.LoadFromFile(InFile : string; out Layout : TrecLang);
var
 strmFile : TFileStream;
begin
 if not FileExists(InFile) then
  raise EFileError.Create('The procedure LoadLayoutFromFile reports: The file '+InFile+' was not found.');

 strmFile := TFileStream.Create(InFile, fmOpenRead);
 try
  strmFile.ReadBuffer(Layout,SizeOf(Layout));
 finally
  strmFile.Free;
 end;
end;

procedure TCurrentLanguages.SetLayoutList(ListType : TListType; List : TStrings);
var
 Layouts : TLayouts;
 Counter : Integer;
 Return  : string;

begin
 try
  if List = nil then //Did you give us an uninitilized list ?
   List := TStrings.Create; //Then create it...
 except
  raise;
 end;

 //Should never happen ... but just in case
 Assert(List <> nil,'The procedure SetLayoutList reports: The List object was not initilized.');

 AvilableLayouts(Layouts); //Reacive the layouts

 Return := '';

 for Counter := 0 to High(Layouts) -1 do
  begin

   case ListType of //So why don't i uses the proc like variable ? well i can not use it on an object procedures/function
                    //Only on a global functions ie not inside an object
    ltID          : GetLanguageID(Layouts[Counter],Return);
    ltLocolized   : GetLanguageLocolizedName(Layouts[Counter],Return);
    ltEnglishName : GetLanguageEnglishName(Layouts[Counter],Return);
    ltShortName   : GetLanguageShortenName(Layouts[Counter],Return);
    ltNativeName  : GetLanguageNativeName(Layouts[Counter],Return);
    ltExtantion   : GetLanguageExtentionName(Layouts[Counter],Return);
   end;

   Assert(Trim(Return)<>'','The procedure SetLayoutList reports: The value of the Return variable is empty');

   try
    List.Add(Return);
   except
    raise;
   end;

   Return := '';
  end;

end;

procedure TCurrentLanguages.SetLayoutList(ListType : Integer; List : TStrings);
var
 Layouts : TLayouts;
 Counter : Integer;
 Return  : string;

begin
 if (ListType < 0) or (ListType>6) then
  raise ERangeError.Create('The procedure SetLayoutList reports: The variable ListType is out of range.');

 try
  if List = nil then //Did you give us an uninitilized list ?
   List := TStrings.Create; //Then create it...
 except
  raise;
 end;

 //Should never happen ... but just in case
 Assert(List <> nil,'The procedure SetLayoutList reports: The List object was not initilized.');

 AvilableLayouts(Layouts); //Reacive the layouts

 Return := '';

 for Counter := 0 to High(Layouts) -1 do
  begin

   case ListType of //So why don't i uses the proc like variable ? well i can not use it on an object procedures/function
                    //Only on a global functions ie not inside an object
    LT_ID          : GetLanguageID(Layouts[Counter],Return);
    LT_LOCOLIZED   : GetLanguageLocolizedName(Layouts[Counter],Return);
    LT_ENGLISHNAME : GetLanguageEnglishName(Layouts[Counter],Return);
    LT_SHORTNAME   : GetLanguageShortenName(Layouts[Counter],Return);
    LT_NATIVENAME  : GetLanguageNativeName(Layouts[Counter],Return);
    LT_EXTANTION   : GetLanguageExtentionName(Layouts[Counter],Return);
   end;

   Assert(Trim(Return)<>'','The procedure SetLayoutList reports: The value of the Return variable is empty');

   try
    List.Add(Return);
   except
    raise;
   end;

   Return := '';
  end;
end;

procedure TCurrentLanguages.SetLayoutList (ListType : string; List : TStrings);
var
 Layouts : TLayouts;
 Counter : Integer;
 Return  : string;

begin
 try
  if List = nil then //Did you give us an uninitilized list ?
   List := TStrings.Create; //Then create it...
 except
  raise;
 end;

 //Should never happen ... but just in case
 Assert(List <> nil,'The procedure SetLayoutList reports: The List object was not initilized.');

 AvilableLayouts(Layouts); //Reacive the layouts

 Return := '';

 for Counter := 0 to High(Layouts) -1 do
  begin

    if (UpperCase(ListType)=LTS_ID) then
     GetLanguageID(Layouts[Counter],Return)
    else
    if (UpperCase(ListType)=LTS_LOCOLIZED) then
     GetLanguageLocolizedName(Layouts[Counter],Return)
    else
    if (UpperCase(ListType)=LTS_ENGLISHNAME) then
     GetLanguageEnglishName(Layouts[Counter],Return)
    else
    if (UpperCase(ListType)=LTS_SHORTNAME) then
     GetLanguageShortenName(Layouts[Counter],Return)
    else
    if (UpperCase(ListType)=LTS_NATIVENAME) then
     GetLanguageNativeName(Layouts[Counter],Return)
    else
    if (UpperCase(ListType)=LTS_EXTANTION) then
     GetLanguageExtentionName(Layouts[Counter],Return)
    else begin
          raise EUnknownIdentifer.CreateFmt('The procedure SetLayoutList reports: The value of the ListType variable (%s) is unkown.',[ListType]);
          Break;
         end;

   Assert(Trim(Return)<>'','The procedure SetLayoutList reports: The value of the Return variable is empty');

   try
    List.Add(Return);
   except
    raise;
   end;

   Return := '';
  end;
end;

function TCurrentLanguages.GetIDFromRecord(DataType : TListType; Value : string) : HKL;
var
 Counter : Integer;
begin
 Result := 0; //Error ... the Result should be any number except 0...
 if Trim(Value)='' then
  begin
   Exit;
  end;

 for Counter := 0 to LayoutNum-1 do
  begin
   try
    case DataType of
     ltID          : begin
                      if (UpperCase(LanguagesList[Counter].strLangID) = UpperCase(Value)) then
                         begin
                          Result := LanguagesList[Counter].hklLangID;
                          break;
                         end;
                     end;

     ltLocolized   :  begin
                       if (UpperCase(LanguagesList[Counter].strSLANGUAGE) = UpperCase(Value)) then
                         begin
                          Result := LanguagesList[Counter].hklLangID;
                          break;
                         end;
                      end;

     ltEnglishName : begin
                      if (UpperCase(LanguagesList[Counter].strSENGLANGUAGE) = UpperCase(Value)) then
                         begin
                          Result := LanguagesList[Counter].hklLangID;
                          break;
                         end;
                     end;

     ltShortName   : begin
                      if (UpperCase(LanguagesList[Counter].strSABBREVLANGNAME) = UpperCase(Value)) then
                         begin
                          Result := LanguagesList[Counter].hklLangID;
                          break;
                         end;
                     end;

     ltNativeName  : begin
                      if (UpperCase(LanguagesList[Counter].strSNATIVELANGNAME) = UpperCase(Value)) then
                         begin
                          Result := LanguagesList[Counter].hklLangID;
                          break;
                         end;
                     end;

     ltExtantion   : begin
                      if (UpperCase(LanguagesList[Counter].strExtention) = UpperCase(Value)) then
                         begin
                          Result := LanguagesList[Counter].hklLangID;
                          break;
                         end;
                     end;
    end; //Case
   except
    on E:EConvertError do
     EConvertError.Create('The function GetIDFromRecord reports: Unable to convert Data types.');
    else raise Exception.Create('The function GetIDFromRecord Reports about unknown exception.');
   end;//Try
  end; //For

end;

procedure TCurrentLanguages.SetLayoutID(const Value : string);
begin
 if (UpperCase(FLayoutID) <> UpperCase(Value)) then
  begin
   FLayoutID := Value;

   ActiveLayout(GetIDFromRecord(ltID,Value));

   if FAutoRefresh then
    Refresh;

   InitilizeLanguagesLists;
  end;
end;

procedure TCurrentLanguages.SetLocolizedName(const Value : string);
begin
 if (UpperCase(FLayoutLocolizedName) <> UpperCase(Value)) then
  begin
   FLayoutLocolizedName := Value;

   ActiveLayout(GetIDFromRecord(ltLocolized,Value));

   if FAutoRefresh then
    Refresh;

   InitilizeLanguagesLists;
  end;
end;

procedure TCurrentLanguages.SetEnglishName(const Value : string);
begin
 if (UpperCase(FLayoutEnglishName) <> UpperCase(Value)) then
  begin
   FLayoutEnglishName := Value;

   ActiveLayout(GetIDFromRecord(ltEnglishName,Value));

   if FAutoRefresh then
    Refresh;

   InitilizeLanguagesLists;
  end;
end;

procedure TCurrentLanguages.SetShortName(const Value : string);
begin
 if (UpperCase(FLayoutShortName) <> UpperCase(Value)) then
  begin
   FLayoutShortName := Value;

   ActiveLayout(GetIDFromRecord(ltShortName,Value));

   if FAutoRefresh then
    Refresh;

   InitilizeLanguagesLists;
  end;
end;

procedure TCurrentLanguages.SetNativeName(const Value : string);
begin
 if (UpperCase(FLayoutNativeName) <> UpperCase(Value)) then
  begin
   FLayoutNativeName := Value;

   ActiveLayout(GetIDFromRecord(ltNativeName,Value));

   if FAutoRefresh then
    Refresh;

   InitilizeLanguagesLists;
  end;
end;

procedure TCurrentLanguages.SetLayoutExtention(const Value : string);
begin
 if (UpperCase(FLayoutExtention) <> UpperCase(Value)) then
  begin
   FLayoutExtention := Value;

   ActiveLayout(GetIDFromRecord(ltExtantion,Value));

   if FAutoRefresh then
    Refresh;

   InitilizeLanguagesLists;
  end;
end;

procedure TCurrentLanguages.SetAutoRefresh(const Value : Boolean);
begin
 if (FAutoRefresh  <> Value) then
  begin
   FAutoRefresh := Value;
  end;
end;

end.


